local bartexture = [=[Interface\AddOns\oUF_zp\texture\minimalist]=]
oUF.colors.power['MANA'] = {26/255, 139/255, 255/255}

local oUFMakeBG = function(parent)
    local bg = parent:CreateTexture(nil, 'BACKGROUND')
    bg:SetPoint('TOPLEFT', parent, -1, 1)
    bg:SetPoint('BOTTOMRIGHT', parent, 1, -1)
    bg:SetTexture(0, 0, 0)
end

local function PostCreateAura(element, button)
	button.icon:SetTexCoord(0.08, 0.92, 0.08, 0.92)
	button.icon:SetDrawLayer('ARTWORK')
	
	button.cd.noCooldownCount = true
end

local function shortval(value)
	if(value >= 1e6) then
		return string.format('%.1fm', value / 1e6)
	elseif(value >= 1e4) then
		return string.format('%.1fk', value / 1e3)
	elseif value >= 1e3 then
		return string.format('%.1fk', value / 1e3)
	else
		return value
	end
end

oUF.Tags['zp:health'] = function(u) 
	return shortval(UnitHealth(u)) 
end
oUF.TagEvents['zp:health'] = 'UNIT_HEALTH'

oUF.Tags['zp:power'] = function(u) 
	return shortval(UnitPower(u)) 
end
oUF.TagEvents['zp:power'] = 'UNIT_ENERGY UNIT_FOCUS UNIT_MANA UNIT_RAGE'

oUF.Tags['zp:name'] = function(u)
	return string.lower(UnitName(u))
end
oUF.TagEvents['zp:name'] = 'UNIT_NAME_UPDATE'

oUFUnitSpecific = {
	player = function(self)
		self:SetWidth(250)
		self:SetHeight(20)

		self.Health = CreateFrame('StatusBar', nil, self)
		self.Health:SetStatusBarTexture(bartexture)
		self.Health:SetHeight(15)

		self.Health:SetPoint'TOPRIGHT'
		self.Health:SetPoint'TOPLEFT'

		self.Health.bg = self.Health:CreateTexture(nil, 'BORDER')
		self.Health.bg:SetAllPoints(self.Health)
		self.Health.bg:SetTexture(bartexture)
		self.Health.bg:SetAlpha(0.3)

		self.Health.colorClass = true
		self.Health.frequentUpdates = true
		
		self.Power = CreateFrame('StatusBar', nil, self)
		self.Power:SetStatusBarTexture(bartexture)
		self.Power:SetHeight(5)
		self.Power:SetPoint('TOP', self.Health, 'BOTTOM', 0, -4)

		self.Power:SetPoint('BOTTOMLEFT', 0, -2.5)
		self.Power:SetPoint('BOTTOMRIGHT', 0, -2.5)
	
		self.Power.bg = self.Power:CreateTexture(nil, 'BORDER')
		self.Power.bg:SetAllPoints(self.Power)
		self.Power.bg:SetTexture(bartexture)
		self.Power.bg:SetAlpha(0.4)

		self.Power.colorPower = true
		self.Power.frequentUpdates = true

		self.RaidIcon = self.Health:CreateTexture(nil, 'OVERLAY')
		self.RaidIcon:SetSize(16, 16)
		self.RaidIcon:SetPoint('TOP', self, 0, 9)

		local curhealth = self.Health:CreateFontString(nil, 'OVERLAY', 'GameFontHighlightSmallLeft')
		curhealth:SetPoint('BOTTOM', self, 0, -28)
		self:Tag(curhealth,'[zp:health]')
	
		local perhealth = self.Health:CreateFontString(nil, 'OVERLAY', 'GameFontHighlightSmallLeft')
		perhealth:SetPoint('BOTTOMLEFT', self, 0, -28)
		self:Tag(perhealth,'[perhp]%')

		local curpower = self.Power:CreateFontString(nil, 'OVERLAY', 'GameFontHighlightSmallLeft')
		curpower:SetPoint('BOTTOMRIGHT', self, 0, -28)
		curpower.frequentUpdates = 0.1
		self:Tag(curpower,'[zp:power]')

		local healthbg = self.Health:CreateTexture(nil, 'BORDER')
		healthbg:SetPoint('CENTER', curhealth, 'CENTER', 0, 0)
		healthbg:SetTexture(bartexture)
		healthbg:SetWidth(253)
		healthbg:SetHeight(13)
		healthbg:SetVertexColor(0, 0, 0, 0.5)

		self.Castbar = CreateFrame('StatusBar', nil, self)
		self.Castbar:SetWidth(252)
		self.Castbar:SetHeight(8)
		self.Castbar:SetStatusBarTexture(bartexture)
	
		self.Castbar.bg = self.Castbar:CreateTexture(nil, 'BORDER')
		self.Castbar.bg:SetAllPoints(self.Castbar)
		self.Castbar.bg:SetTexture(bartexture)
		self.Castbar.bg:SetVertexColor(0, 0, 0)
		
		self.Castbar.Text = self.Castbar:CreateFontString(nil, 'OVERLAY', 'GameFontHighlightSmallLeft')
		self.Castbar.Text:SetPoint('LEFT', self.Castbar, 0, 12)
		self.Castbar.Text:SetTextColor(1, 1, 1)
	
		self.Castbar.Time = self.Castbar:CreateFontString(nil, 'OVERLAY', 'GameFontHighlightSmallRight')
		self.Castbar.Time:SetPoint('RIGHT', self.Castbar, -3, 12)
		self.Castbar.Time:SetTextColor(1, 1, 1)

		self.Castbar:SetPoint('CENTER', oUF.units.player, 'CENTER', 1, -80)
		self.Castbar:SetStatusBarColor(1, 0.50, 0)
	
		oUFMakeBG(self.Health)
		oUFMakeBG(self.Power)
		oUFMakeBG(self.Castbar)
	end,
	focus = function(self)
		self:SetWidth(100)
		self:SetHeight(15)
		
		self.Health = CreateFrame('StatusBar', nil, self)
		self.Health:SetStatusBarTexture(bartexture)
		self.Health:SetHeight(15)

		self.Health:SetPoint('TOPRIGHT', 0, -1.5)
		self.Health:SetPoint('TOPLEFT', 0, -1.5)

		self.Health.bg = self.Health:CreateTexture(nil, 'BORDER')
		self.Health.bg:SetAllPoints(self.Health)
		self.Health.bg:SetTexture(bartexture)
		self.Health.bg:SetAlpha(0.4)
	
		self.Health.colorClass = true
		self.Health.colorTapping = true
		self.Health.colorReaction = true

		local unitname = self.Health:CreateFontString(nil, 'OVERLAY', 'GameFontHighlightSmallLeft')
		self:Tag(unitname,'[zp:name]')
		unitname:SetPoint('LEFT', self, 0, -1)
		unitname:SetWidth(90)
		unitname:SetHeight(10)

		oUFMakeBG(self.Health)
	end,
	pet = function(self)
		self:SetWidth(101)
		self:SetHeight(15)
		
		self.Health = CreateFrame('StatusBar', nil, self)
		self.Health:SetStatusBarTexture(bartexture)
		self.Health:SetHeight(15)

		self.Health:SetPoint('TOPRIGHT', 0, -1.5)
		self.Health:SetPoint('TOPLEFT', 0, -1.5)

		self.Health.bg = self.Health:CreateTexture(nil, 'BORDER')
		self.Health.bg:SetAllPoints(self.Health)
		self.Health.bg:SetTexture(bartexture)
		self.Health.bg:SetAlpha(0.4)
	
		self.Health.colorClass = true
		self.Health.colorTapping = true
		self.Health.colorReaction = true

		local unitname = self.Health:CreateFontString(nil, 'OVERLAY', 'GameFontHighlightSmallLeft')
		self:Tag(unitname,'[zp:name]')
		unitname:SetPoint('LEFT', self, 0, -1)
		unitname:SetWidth(90)
		unitname:SetHeight(10)

		oUFMakeBG(self.Health)
	end,
	target = function(self)
		self:SetWidth(250)
		self:SetHeight(20)

		self.Health = CreateFrame('StatusBar', nil, self)
		self.Health:SetStatusBarTexture(bartexture)
		self.Health:SetHeight(15)

		self.Health:SetPoint'TOPRIGHT'
		self.Health:SetPoint'TOPLEFT'

		self.Health.bg = self.Health:CreateTexture(nil, 'BORDER')
		self.Health.bg:SetAllPoints(self.Health)
		self.Health.bg:SetTexture(bartexture)
		self.Health.bg:SetAlpha(0.3)

		self.Health.colorClass = true
		self.Health.colorTapping = true
		self.Health.colorReaction = true
		self.Health.frequentUpdates = true
		
		self.Power = CreateFrame('StatusBar', nil, self)
		self.Power:SetStatusBarTexture(bartexture)
		self.Power:SetHeight(5)
		self.Power:SetPoint('TOP', self.Health, 'BOTTOM', 0, -4)

		self.Power:SetPoint('BOTTOMLEFT', 0, -2.5)
		self.Power:SetPoint('BOTTOMRIGHT', 0, -2.5)
	
		self.Power.bg = self.Power:CreateTexture(nil, 'BORDER')
		self.Power.bg:SetAllPoints(self.Power)
		self.Power.bg:SetTexture(bartexture)
		self.Power.bg:SetAlpha(0.4)

		self.Power.colorPower = true
	
		local unitname = self.Health:CreateFontString(nil, 'OVERLAY', 'GameFontHighlightSmallLeft')
		self:Tag(unitname,'[zp:name]')
		unitname:SetPoint('LEFT', self, -1, 20)

		self.RaidIcon = self.Health:CreateTexture(nil, 'OVERLAY')
		self.RaidIcon:SetSize(16, 16)
		self.RaidIcon:SetPoint('TOP', self, 0, 9)

		local curhealth = self.Health:CreateFontString(nil, 'OVERLAY', 'GameFontHighlightSmallLeft')
		curhealth:SetPoint('BOTTOM', self, 0, -28)
		self:Tag(curhealth,'[zp:health]')
	
		local perhealth = self.Health:CreateFontString(nil, 'OVERLAY', 'GameFontHighlightSmallLeft')
		perhealth:SetPoint('BOTTOMLEFT', self, 0, -28)
		self:Tag(perhealth,'[perhp]%')

		local healthbg = self.Health:CreateTexture(nil, 'BORDER')
		healthbg:SetPoint('CENTER', curhealth, 'CENTER', 0, 0)
		healthbg:SetTexture(bartexture)
		healthbg:SetWidth(253)
		healthbg:SetHeight(13)
		healthbg:SetVertexColor(0, 0, 0, 0.5)

		self.Buffs = CreateFrame('Frame', nil, self)
		self.Buffs.size = 18
		self.Buffs:SetHeight(self.Buffs.size)
		self.Buffs:SetWidth(self.Buffs.size * 5)
		self.Buffs:SetPoint('BOTTOMLEFT', self, 'TOPLEFT', 0, 20)
		self.Buffs.initialAnchor = 'BOTTOMLEFT'
		self.Buffs['growth-y'] = 'TOP'
		self.Buffs.num = 20
		self.Buffs.spacing = 2
		self.Buffs.PostCreateIcon = PostCreateAura

		self.Debuffs = CreateFrame('Frame', nil, self)
		self.Debuffs.size = 18
		self.Debuffs:SetHeight(self.Debuffs.size)
		self.Debuffs:SetWidth(self.Debuffs.size * 13)
		self.Debuffs:SetPoint('TOPLEFT', self, 'BOTTOMLEFT', 0, -32)
		self.Debuffs.initialAnchor = 'TOPLEFT'
		self.Debuffs['growth-y'] = 'DOWN'
		self.Debuffs.num = 12
		self.Debuffs.spacing = 2
		self.Debuffs.PostCreateIcon = PostCreateAura

		self.CPoints = {}
		for id = 1, MAX_COMBO_POINTS do
			self.CPoints[id] = CreateFrame('StatusBar', nil, self)

			if (id > 1) then
				self.CPoints[id]:SetPoint('LEFT', self.CPoints[id-1], 'RIGHT', 4, 0)
			else
				self.CPoints[id]:SetPoint('BOTTOMLEFT', oUF.units.target, 'BOTTOMLEFT', 0, -12)
			end

			self.CPoints[id]:SetStatusBarTexture(bartexture)
			self.CPoints[id]:SetStatusBarColor(1, 0.8, 0)
			self.CPoints[id]:SetHeight(4)
			self.CPoints[id]:SetWidth(234 / MAX_COMBO_POINTS)
			oUFMakeBG(self.CPoints[id])
		end

		self.Castbar = CreateFrame('StatusBar', nil, self)
		self.Castbar:SetWidth(252)
		self.Castbar:SetHeight(8)
		self.Castbar:SetStatusBarTexture(bartexture)
	
		self.Castbar.bg = self.Castbar:CreateTexture(nil, 'BORDER')
		self.Castbar.bg:SetAllPoints(self.Castbar)
		self.Castbar.bg:SetTexture(bartexture)
		self.Castbar.bg:SetVertexColor(0, 0, 0)
		
		self.Castbar.Text = self.Castbar:CreateFontString(nil, 'OVERLAY', 'GameFontHighlightSmallLeft')
		self.Castbar.Text:SetPoint('LEFT', self.Castbar, 0, 12)
		self.Castbar.Text:SetTextColor(1, 1, 1)
	
		self.Castbar.Time = self.Castbar:CreateFontString(nil, 'OVERLAY', 'GameFontHighlightSmallRight')
		self.Castbar.Time:SetPoint('RIGHT', self.Castbar, -3, 12)
		self.Castbar.Time:SetTextColor(1, 1, 1)

		self.Castbar:SetPoint('CENTER', oUF.units.target, 'CENTER', 1, -80)
		self.Castbar:SetStatusBarColor(0.80, 0.01, 0)
	
		oUFMakeBG(self.Health)
		oUFMakeBG(self.Power)
		oUFMakeBG(self.Castbar)
	end,
	targettarget = function(self)
		self:SetWidth(100)
		self:SetHeight(15)
		
		self.Health = CreateFrame('StatusBar', nil, self)
		self.Health:SetStatusBarTexture(bartexture)
		self.Health:SetHeight(15)

		self.Health:SetPoint('TOPRIGHT', 0, -1.5)
		self.Health:SetPoint('TOPLEFT', 0, -1.5)

		self.Health.bg = self.Health:CreateTexture(nil, 'BORDER')
		self.Health.bg:SetAllPoints(self.Health)
		self.Health.bg:SetTexture(bartexture)
		self.Health.bg:SetAlpha(0.4)

		self.Health.colorClass = true
		self.Health.colorTapping = true
		self.Health.colorReaction = true

		local unitname = self.Health:CreateFontString(nil, 'OVERLAY', 'GameFontHighlightSmallLeft')
		self:Tag(unitname,'[zp:name]')
		unitname:SetPoint('LEFT', self, 0, -1)
		unitname:SetWidth(90)
		unitname:SetHeight(10)

		oUFMakeBG(self.Health)
	end,
}